/***************************************************************************
 *   Copyright (C) 2004 by erss                                            *
 *   erss@mail.ru                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef REER_H
#define REER_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kglobal.h>
#include <klocale.h>
#include <kapplication.h>
#include <qheader.h>
#include <kpanelapplet.h>
#include <kmessagebox.h>
#include <kcombobox.h>
#include <qmainwindow.h>
#include <qtextbrowser.h> 
#include <qsettings.h>
#include <qpushbutton.h>
#include <qhbox.h>
#include <qlayout.h>
#include <qlineedit.h>
#include <kfiledialog.h>
#include <kdirselectdialog.h>
#include <qtextcodec.h>
#include <qlabel.h>
#include <qprogressdialog.h>
#include <qfile.h>
#include <qdir.h>
#include <qfileinfo.h>
#include <qtextstream.h>
#include <qregexp.h>
#include <qstringlist.h>
#include <qtooltip.h>
#include <qcheckbox.h>
#include <qlistview.h>
#include <qfileinfo.h>
#include <arts/kplayobject.h>
#include <arts/kplayobjectfactory.h>
#include <arts/kartsdispatcher.h>
#include <arts/kartsserver.h>

class maListBox;

class maDictionary {
public:
  maDictionary( QString n );
  maDictionary();
  ~maDictionary();
  void setName( QString );
  QStringList grep( QRegExp );
  QStringList grepp( QRegExp );
  uint count() { return index.count(); };
  QString getName() { return name; };
private:
  void loadIndex();
  QString name;
  QStringList index;
};

typedef QMap<QString,maDictionary > mapDict;

class appler : public KPanelApplet
{
  Q_OBJECT
public:
  appler(const QString& configFile, Type t = Normal, int actions = 0,
         QWidget *parent = 0, const char *name = 0);
  ~appler();
  virtual int widthForHeight(int height) const;
  virtual int heightForWidth(int width) const;
  virtual void about();
  virtual void help();
  virtual void preferences();
protected:
  void resizeEvent(QResizeEvent *);
  bool eventFilter( QObject *, QEvent * );
protected slots:
  void showWord( const QString& );
  void slShowArticle( const QString&, const QString& );
private:
  void reloadConfig();
  KHistoryCombo *input;
  QTextCodec *codec;
  QString DictName;
  bool useRegExp;
  mapDict dicts;
};

class wordWindow : public QMainWindow
{
  Q_OBJECT
public:
  wordWindow( QString txt, QWidget *parent=0, const char *name=0, WFlags f=WType_TopLevel );
  ~wordWindow();
protected:
  void keyPressEvent( QKeyEvent *e );
protected slots:
  void slPlaySound( const QString & );
private:
  QTextBrowser *text;
  QString enWord;
  KArtsDispatcher* dispatcher;
  Arts::SoundServer server;
};

class wordList : public QMainWindow
{
  Q_OBJECT
public:
  wordList( QStringList lst, QWidget *parent=0, const char *name=0, WFlags f=WType_TopLevel );
  ~wordList();
protected:
  void keyPressEvent( QKeyEvent *e );
protected slots:
  void slDoubleClicked( QListViewItem *, const QPoint &, int );
signals:
  void selected(const QString&, const QString& );
private:
  QListView *lvWords;
};

class setup : public QDialog
{
  Q_OBJECT
public:
  setup( QWidget *parent=0, const char *name=0 );
  ~setup();
protected slots:
  void slotSetDict();
  void slotSetDir();
  void slotOkPressed();
  void slotCancelPressed();
  void slotIndex();
private:
  void setDictsList( QListViewItem *item );
  QLineEdit *leDict;
  QLineEdit *leWords;
  QTextCodec *codec;
  QCheckBox *cbRegExp;
  QListView *lvDicts;
};

class myListViewItem: public QListViewItem 
{
public:
  myListViewItem( QListView *parent );
  myListViewItem ( QListView *parent, QListViewItem *after );
  ~myListViewItem();
virtual void paintCell( QPainter *p, const QColorGroup &cg, int column, int width, int alignment );
};
#endif
